Class.create(function(Super)
 /**
  * JavaScriptDocument(=JSD)IuWFNgNX
  * @param Super [Function|null] X[p[NX
  * @return Function js.debug.jsd.JavaScriptDocumentNX
  * 
  * @package js.debug.jsd
  * @update 2007/10/06
  * @version 3.00.00
  * @author Mug
  * @copyright (C) 2005-2007 Mug, All rights reserved.
  * 
  * @explanation <p>̃NXJavaScriptDocumentiȉJSDƗjRgɏꂽIuWFNgir[jƂĕێ邽߂̃NXłB</p>
  *   <p>JSDIuWFNg1:N̐eq\Ƃ邱ƂłB<var>js.debug.jsd.JsdFactory</var>IuWFNg<var>create()</var>\bh̖߂ĺA
  *   NG[^[iNX𐶐֐jJSDeƂȂANX̃o[ivpeBC\bhCRXgN^ȂǁjJSDqƂĕŒ񋟂B</p>
  * 
  * @history 2007/10/06 3.00.00 r[EKw\
  * @history 2007/04/29 2.02.05 ̋LqJn
  */
  {
  //##############################################################################
  //
  // wb_(vpeBEpENXpX)
  //
  //
  // vpeB - NXɊւ郁^f[^
  //
  //:V Creator Function NXNG[^[
  var Creator = arguments.callee;
  // SCNX
  Creator.CompleteName = "js.debug.jsd.JavaScriptDocument";
  
  //
  // p - vg^CvpƊ{õZbg
  //
  // p
  Creator.inherit(Class, Super);
  //:V Static Object StaticIuWFNg
  var Static = Class.Static;
  //:V Proto Object vg^CvIuWFNg
  var Proto = Class.prototype;
  
  //
  // NXpX
  //
  // js.debug.jsd.command.AbstractCommand̎Q
  var AbstractCommand = js.debug.jsd.command.AbstractCommand;
  
  //##############################################################################
  //
  // {fB(vCx[gENXEStaticEvg^CvE)
  //
  //
  // vCx[g - NX̔Joƃ\bh(pȂ)
  //
  
  //
  // NX - NX̌Joƃ\bh(pȂ)
  //
  
  //
  // Static - NX.StatičJoƃ\bh(p)
  //
  
  //
  // vg^Cv - NX.prototypěJoƃ\bh(p)
  //
  //------------------------------------------------------------------------------
  Proto.hasCommand = function(name)
   /**
    * ̃R}hĂ邩ǂ擾
    * @return Boolean R}hĂ邩ǂ
    */
    {
    return !!this.getCommandByName(name);
    };
  
  //
  //  - NX`ɂP񂾂s
  //
  
  //##############################################################################
  //
  // RXgN^(vCx[gEthisERXgN^)
  //
  function Class()
   /**
    * JavaScriptDocumentIuWFNgNX̃RXgN^
    * @return js.debug.jsd.JavaScriptDocument CX^X
    */
    {
    //
    // X[p[NXKp(p) - X[p[NX̃RXgN^N
    //
    //Super.apply(this, arguments);
    
    //
    // vCx[g - CX^X̔Joƃ\bh(pȂ)
    //
    //:v commands Array R}hf[^Xg
    var commands = [];
    //:v children Array|null qJSDCX^X
    var children = null;
    
    //
    // this - CX^X̌Joƃ\bh(Kpɂp)
    //
    //------------------------------------------------------------------------------
    this.getCommands = function()
     /**
      * R}hf[^Xg擾
      * @return Array R}hf[^Xg(ShallowCopyi󂢃Rs[j)
      */
      {
      var list = [];
      for(var i = 0; i < commands.length; i++)
        {
        list[i] = commands[i];
        }
      return list;
      };
    //------------------------------------------------------------------------------
    this.getCommandByName = function(name)
     /**
      * R}hR}hf[^擾
      * @notice R}hf[^Xg̒ōŏɈv̂ԂB
      * @param name String R}h
      * @return js.debug.jsd.command.AbstractCommand|null R}hf[^
      * @throw StringFormatException@Error namev~eBuString^łȂꍇ
      */
      {
      if((typeof name) != "string")
        {
        throw new Error("StringFormatException", Creator.CompleteName, {variable:"name", value:name, type:(typeof name)});
        }
      var cmdObj = null;
      for(var i = 0; i < commands.length; i++)
        {
        if(commands[i].getCommand() == name)
          {
          cmdObj = commands[i];
          break;
          }
        }
      return cmdObj;
      };
    //------------------------------------------------------------------------------
    this.getCommandsByName = function(name)
     /**
      * R}hR}hf[^XgŎ擾
      * @notice R}hf[^Xg̒ňv̂XgŕԂB
      * @param name String R}h
      * @return Array js.debug.jsd.command.AbstractCommand̔z
      * @throw StringFormatException@Error namev~eBuString^łȂꍇ
      */
      {
      if((typeof name) != "string")
        {
        throw new Error("StringFormatException", Creator.CompleteName, {variable:"name", value:name, type:(typeof name)});
        }
      var cmdList = [];
      for(var i = 0; i < commands.length; i++)
        {
        if(commands[i].getCommand() == name)
          {
          cmdList[cmdList.length] = commands[i];
          }
        }
      return cmdList;
      };
    //------------------------------------------------------------------------------
    this.addCommand = function(command)
     /**
      * R}hf[^ǉ
      * @param command js.debug.jsd.command.AbstractCommand JSDR}hIuWFNg
      * @throw FormatException@Error commandjs.debug.jsd.command.AbstractCommand^łȂꍇ
      * @throw DoubleDefinitionException@Error ǉ悤ƂR}hLqłȂ̂ɁAɂ̃R}hێĂꍇ
      */
      {
      if(!(command instanceof AbstractCommand))
        {
        throw new Error("FormatException", Creator.CompleteName, {variable:"command", format:"js.debug.jsd.command.AbstractCommand", value:command, type:(typeof command)});
        }
      var name = command.getCommand();
      if(!command.constructor.Static.complexDefine && this.hasCommand(name))
        {
        throw new Error("DoubleDefinitionException", Creator.CompleteName, ("JSDR}hu" + name + "v͕Lqł܂B"));
        }
      commands[commands.length] = command;
      };
    //------------------------------------------------------------------------------
    this.putCommand = function(command)
     /**
      * R}hf[^ǉ܂͏㏑
      * @explanation <p>R}hLqłAɓR}hf[^ێꍇ͏㏑AȊȌꍇ͒ǉB</p>
      * @param command js.debug.jsd.command.AbstractCommand JSDR}hIuWFNg
      * @throw FormatException@Error commandjs.debug.jsd.command.AbstractCommand^łȂꍇ
      */
      {
      if(!(command instanceof AbstractCommand))
        {
        throw new Error("FormatException", Creator.CompleteName, {variable:"command", format:"js.debug.jsd.command.AbstractCommand", value:command, type:(typeof command)});
        }
      var name = command.getCommand();
      var index = commands.length;
      if(!command.constructor.Static.complexDefine)
        {
        for(var i = 0; i < commands.length; i++)
          {
          if(commands[i].getCommand() == name)
            {
            index = i;
            break;
            }
          }
        }
      commands[index] = command;
      };
    //------------------------------------------------------------------------------
    this.delCommand = function(command)
     /**
      * R}hf[^폜
      * @param command js.debug.jsd.command.AbstractCommand JSDR}hIuWFNgiIuWFNg폜j
      * @throw FormatException@Error commandjs.debug.jsd.command.AbstractCommand^łȂꍇ
      */
      {
      if(!(command instanceof AbstractCommand))
        {
        throw new Error("FormatException", Creator.CompleteName, {variable:"command", format:"js.debug.jsd.command.AbstractCommand", value:command, type:(typeof command)});
        }
      for(var i = 0; i < commands.length; i++)
        {
        if(command)
          {
          if(command == commands[i])
            {
            command = null;
            }
          }
        if(!command)
          {
          commands[i] = ((i + 1) < commands.length) ? commands[i + 1] : null;
          }
        }
      if(!command)
        {
        commands.length--;
        }
      };
    //------------------------------------------------------------------------------
    this.delCommandsByName = function(name)
     /**
      * R}hR}hf[^폜
      * @notice R}hf[^Xg̒ňv̂폜B
      * @param name String R}h
      * @return Number 폜R}hf[^
      * @throw StringFormatException@Error namev~eBuString^łȂꍇ
      */
      {
      if((typeof name) != "string")
        {
        throw new Error("StringFormatException", Creator.CompleteName, {variable:"name", value:name, type:(typeof name)});
        }
      var count = 0;
      for(var i = 0; i < commands.length; i++)
        {
        if(commands[i].getCommand() != name)
          {
          if(i != count)
            {
            commands[count] = commands[i];
            }
          count++;
          }
        }
      count = commands.length - count;
      if(count != 0)
        {
        commands.length -= count;
        }
      return count;
      };
    //------------------------------------------------------------------------------
    this.hasChild = function(child)
     /**
      * wJSDCX^XqJSDƂĕێĂ邩ǂ
      * @param child js.debug.jsd.JavaScriptDocument Ă邩ȂJSDCX^X
      * @return Boolean qJSDƂĕێĂ邩ǂ
      * @throw FormatException@Error childjs.debug.jsd.JavaScriptDocument^łȂꍇ
      */
      {
      if(!(child instanceof Class))
        {
        throw new Error("FormatException", Creator.CompleteName, {variable:"child", format:Creator.CompleteName, value:child, type:(typeof child)});
        }
      if(children)
        {
        for(var i = 0; i < children.length; i++)
          {
          if(children[i] == child)
            {
            return true;
            }
          }
        }
      return false;
      };
    //------------------------------------------------------------------------------
    this.getChildren = function()
     /**
      * qJSDVȔzŎ擾
      * @return Array qJSD̔z(ShallowCopyi󂢃Rs[j)
      */
      {
      var c = [];
      if(children)
        {
        for(var i = 0; i < children.length; i++)
          {
          c[i] = children[i];
          }
        }
      return c;
      };
    //------------------------------------------------------------------------------
    this.addChild = function(child)
     /**
      * VJSDCX^XqJSDƂĉ
      * @param child js.debug.jsd.JavaScriptDocument VJSDCX^X
      * @throw FormatException@Error childjs.debug.jsd.JavaScriptDocument^łȂꍇ
      * @throw DoubleDefinitionException@Error childJSDCX^XɎqJSDƂĕێĂꍇ
      */
      {
      if(!(child instanceof Class))
        {
        throw new Error("FormatException", Creator.CompleteName, {variable:"child", format:Creator.CompleteName, value:child, type:(typeof child)});
        }
      if(this.hasChild(child))
        {
        throw new Error("DoubleDefinitionException", Creator.CompleteName, "ɎqJSDƂĕێĂJSDCX^XɎqJSDɉ邱Ƃ͂ł܂B");
        }
      if(!children)
        {
        children = [];
        }
      children[children.length] = child;
      };
    //------------------------------------------------------------------------------
    this.removeChild = function(child)
     /**
      * wJSDCX^XqJSD폜
      * @param child js.debug.jsd.JavaScriptDocument Ă邩ȂJSDCX^X
      * @throw FormatException@Error childjs.debug.jsd.JavaScriptDocument^łȂꍇ
      */
      {
      if(!(child instanceof Class))
        {
        throw new Error("FormatException", Creator.CompleteName, {variable:"child", format:Creator.CompleteName, value:child, type:(typeof child)});
        }
      if(children)
        {
        var c = [];
        for(var i = 0; i < children.length; i++)
          {
          if(children[i] != child)
            {
            c[c.length] = children[i];
            }
          }
        children = (c.length > 0) ? c : null;
        }
      };
    
    //
    // RXgN^ - CX^X̌Joƃ\bh(pȂ)
    //
    return this;
    }
  
  return Class;
  });

