Class.create(function(Super)
 /**
  * ۃ\[X̓NX
  * @param Super [Function|null] X[p[NX
  * @return Function js.debug.jsd.parser.AbstractParserNX
  * 
  * @package js.debug.jsd.parser
  * @update 2007/10/06
  * @version 1.00.00
  * @author Mug
  * @copyright (C) 2007 Mug, All rights reserved.
  * 
  * @explanation <p>̃NXECMAScript̃\[XR[h͂AJSDRgJSDIuWFNgɂ邽߂̃p[T[NX̒ۃNXłB
  *   ۂɂ̓TuNX`A<var>js.debug.jsd.JsdFactory</var>NX<var>registParser</var>\bhpēo^邱ƂɂĎgp\ƂȂB
  *   <var>registParser</var>\bh́Aォo^ꂽNXقǗDi\[XR[h㓯ӏ͑ΏۂƂƂ̂݁j悤ɂȂĂ邽߁A
  *   AƎ̉̓[ǉȂ΂ȂȂꍇłΉ\łBAʏ͂<var>js.debug.jsd.parser</var>pbP[WɊ܂܂eNXŏ\łB</p>
  * 
  * @example <p>AƎ̃TuNXǉKvꍇ̎菇ȉɎB
  *   <ol>
  *     <li>̃NX̃TuNX쐬B</li>
  *     <li>TuNX<var>Static.PATTERN</var>B<br /><var>RegExp</var>IuWFNgłAO[o}b`łKvB</li>
  *     <li>TuNX<var>Static.ALTERNATE</var>B<br />͏ȃ\[XR[h̍\͂sہAꎞIɒu镶łB</li>
  *     <li>TuNX<var>prototype.parse</var>B<br />̓RXgN^<var>range</var>ƁA<var>parse</var>\bḧ<var>aroundSource</var>JSDIuWFNg𐶐ĕԂ\bhłB</li>
  *     <li>TuNX̏<kbd>js.debug.jsd.JsdFactory.registParser(NX);</kbd>B</li>
  *     <li>ǂݍݏ̂߂ɁiKvł΁jˑǉB<br />ƂNX`̃TuNX͏D悳ꍇÃTuNẌˑɂ`ǉB</li>
  *   </ol></p>
  */
  {
  //##############################################################################
  //
  // wb_(vpeBEpENXpX)
  //
  //
  // vpeB - NXɊւ郁^f[^
  //
  //:V Creator Function NXNG[^[
  var Creator = arguments.callee;
  // SCNX
  Creator.CompleteName = "js.debug.jsd.parser.AbstractParser";
  
  //
  // p - vg^CvpƊ{õZbg
  //
  // p
  Creator.inherit(Class, Super);
  //:V Static Object StaticIuWFNg
  var Static = Class.Static;
  //:V Proto Object vg^CvIuWFNg
  var Proto = Class.prototype;
  
  //
  // NXpX
  //
  //:V SourcePoint Function js.debug.jsd.parser.SourcePoint̎Q
  var SourcePoint = js.debug.jsd.parser.SourcePoint;
  //:V SourceRange Function js.debug.jsd.parser.SourceRange̎Q
  var SourceRange = js.debug.jsd.parser.SourceRange;
  
  //##############################################################################
  //
  // {fB(vCx[gENXEStaticEvg^CvE)
  //
  //
  // vCx[g - NX̔Joƃ\bh(pȂ)
  //
  //:V TARGET_PATTERN_FUNCTION RegExp ^[Qbgp̐K\(function)
  var TARGET_PATTERN_FUNCTION = /(?:^|\s|\W)function\s+(\S+)\s*\(/;
  //:V TARGET_PATTERN_VAR RegExp ^[Qbgp̐K\(var)
  var TARGET_PATTERN_VAR = /(?:^|\s|\W)var\s+(\S+)\s*(?:=(?:\s*function\W)?|;)/;
  //:V TARGET_PATTERN_CLASS RegExp ^[Qbgp̐K\(Class)
  var TARGET_PATTERN_CLASS = /(?:^|\s|\W)Class\.(\S+)\s*=(?:\s*function\W)?/;
  //:V TARGET_PATTERN_STATIC RegExp ^[Qbgp̐K\(Static)
  var TARGET_PATTERN_STATIC = /(?:^|\s|\W)Static\.(\S+)\s*=(?:\s*function\W)?/;
  //:V TARGET_PATTERN_PROTO RegExp ^[Qbgp̐K\(Proto)
  var TARGET_PATTERN_PROTO = /(?:^|\s|\W)Proto\.(\S+)\s*=(?:\s*function\W)?/;
  //:V TARGET_PATTERN_PROTOTYPE RegExp ^[Qbgp̐K\(prototype)
  var TARGET_PATTERN_PROTOTYPE = /(?:^|\s|\W)prorotype\.(\S+)\s*=(?:\s*function\W)?/;
  //:V TARGET_PATTERN_THIS RegExp ^[Qbgp̐K\(this)
  var TARGET_PATTERN_THIS = /(?:^|\s|\W)this\.(\S+)\s*=(?:\s*function\W)?/;
  
  //
  // NX - NX̌Joƃ\bh(pȂ)
  //
  
  //
  // Static - NX.StatičJoƃ\bh(p)
  //
  //:S PATTERN RegExp|null YiTuNXŃI[o[Chj
  Static.PATTERN = null;
  //:S ALTERNATE String|null ֕iTuNXŃI[o[Chj
  Static.ALTERNATE = null;
  
  //------------------------------------------------------------------------------
  Static.substitute = function(str)
   /**
    * w肳ꂽ̕u镶擾
    * @notice TuNXs邱ƁB
    * @param str String|Number ܂͂̒
    * @return String uׂ
    */
    {
    var len = 0;
    if((typeof str) == "string")
      {
      len = str.length;
      }
    else if(((typeof str) == "number") && !isNaN(str))
      {
      len = str;
      }
    else if(!str)
      {
      len = 0;
      }
    else
      {
      str = "" + str;
      len = str.length;
      }
    str = "";
    if(((typeof this.ALTERNATE) == "string") && (this.ALTERNATE.length > 0))
      {
      while((len--) > 0)
        {
        str += this.ALTERNATE;
        }
      }
    return str;
    };
  //------------------------------------------------------------------------------
  Static.findTarget = function(source)
   /**
    * ^[Qbg
    * @param source String 팟i\[Xj
    * @return js.debug.jsd.parser.SourceRange|null ʁivpeBdefF,V,C,S,P,Îꂩݒ肳j
    * @throw StringFormatException@Error sourcev~eBuString^łȂꍇ
    */
    {
    if((typeof source) != "string")
      {
      throw new Error("StringFormatException", Creator.CompleteName, {variable:"source", value:source, type:(typeof source)});
      }
    var range = null;
    if((/^\s*$/).test(source))
      {
      return range;
      }
    // K\̌ʂSourceRangeCX^X𐶐
    function createRange(matches)
      {
      var range = new SourceRange();
      range.value = matches[1];
      range.begin = new SourcePoint();
      range.begin.charIndex = source.indexOf(matches[0], 0) + matches[0].indexOf(matches[1], 0);
      range.end = new SourcePoint();
      range.end.charIndex = range.begin.charIndex + range.value.length;
      if(matches[0].indexOf("function", 0) >= 0)
        {
        range.type = "Function";
        }
      return range;
      }
    // function
    if(TARGET_PATTERN_FUNCTION.test(source))
      {
      range = createRange(TARGET_PATTERN_FUNCTION.exec(source));
      range.def = "F";
      }
    // var
    if(TARGET_PATTERN_VAR.test(source))
      {
      range = createRange(TARGET_PATTERN_VAR.exec(source));
      range.def = "V";
      }
    // Class
    if(TARGET_PATTERN_CLASS.test(source))
      {
      range = createRange(TARGET_PATTERN_CLASS.exec(source));
      range.def = "C";
      }
    // Static
    if(TARGET_PATTERN_STATIC.test(source))
      {
      range = createRange(TARGET_PATTERN_STATIC.exec(source));
      range.def = "S";
      }
    // Proto
    if(TARGET_PATTERN_PROTO.test(source))
      {
      range = createRange(TARGET_PATTERN_PROTO.exec(source));
      range.def = "P";
      }
    // prototype
    if(TARGET_PATTERN_PROTOTYPE.test(source))
      {
      range = createRange(TARGET_PATTERN_PROTOTYPE.exec(source));
      range.def = "P";
      }
    // this
    if(TARGET_PATTERN_THIS.test(source))
      {
      range = createRange(TARGET_PATTERN_THIS.exec(source));
      range.def = "I";
      }
    return range;
    };
  
  //
  // vg^Cv - NX.prototypěJoƃ\bh(p)
  //
  //:P target js.debug.jsd.parser.SourceRange|null ͑Ώۃ\[XΏۂƂϐ̏ꏊ
  Proto.target = null;
  //:P jsd js.debug.jsd.JavaScriptDocument|null ͂ĐꂽJSDCX^X
  Proto.jsd = null;
  
  //------------------------------------------------------------------------------
  Proto.parse = function(aroundSource)
   /**
    * \[XJSDIuWFNgɃp[X
    * @notice ̃\bh̓TuNXŃI[o[Ch邱ƁB
    * @param aroundSource Array|String|null ͂̃\[X
    * @return js.debug.jsd.JavaScriptDocument|null ͂ĐꂽJSDCX^X
    * @throw SystemError@Error ̃\bhTuNXŃI[o[ChĂȂꍇ
    */
    {
    throw new Error("SystemError", Creator.CompleteName, "js.debug.jsd.parser.AbstractParser.prorotype.parse\bhTuNXŃI[o[ChĂ܂B");
    };
  
  //
  //  - NX`ɂP񂾂s
  //
  
  //##############################################################################
  //
  // RXgN^(vCx[gEthisERXgN^)
  //
  function Class(range)
   /**
    * ۃ\[X̓NX̃RXgN^
    * @param range js.debug.jsd.parser.SourceRange ͑Ώۂ̃\[X͈̔͂ƒl
    * @return js.debug.jsd.parser.AbstractParser ̃NX̃TuNX̃CX^X
    * @throw SystemError@Error ̃NX̃TuNXnewĊԐړIɌĂяoĂȂꍇ
    * @throw FormatException@Error rangeSourceRangẽCX^XłȂꍇ
    */
    {
    if(!(this instanceof Class) || (this.constructor == Class))
      {
      throw new Error("SystemError", Creator.CompleteName, "AbstractParser̃TuNXnewȂ΂Ȃ܂B");
      }
    if(!(range instanceof SourceRange))
      {
      throw new Error("FormatException", Creator.CompleteName, {variable:"range", format:"js.debug.jsd.parser.SourceRange", value:range, type:(typeof range)});
      }
    //
    // X[p[NXKp(p) - X[p[NX̃RXgN^N
    //
    //Super.apply(this, arguments);
    
    //
    // vCx[g - CX^X̔Joƃ\bh(pȂ)
    //
    
    //
    // this - CX^X̌Joƃ\bh(Kpɂp)
    //
    this.getRange = function()
     /**
      * \[XWiN[j擾
      * @return js.debug.jsd.parser.SourceRange \[XW
      */
      {
      return range.clone();
      };
    
    //
    // RXgN^ - CX^X̌Joƃ\bh(pȂ)
    //
    return this;
    }
  
  return Class;
  });

