Class.create(function(Super)
 /**
  * \[X|CgNX
  * @param Super [Function|null] X[p[NX
  * @return Function js.debug.jsd.parser.SourcePointNX
  * 
  * @package js.debug.jsd.parser
  * @update 2007/11/11
  * @version 1.01.00
  * @author Mug
  * @copyright (C) 2007 Mug, All rights reserved.
  * 
  * @explanation <p>\[XR[ḧʒur[NXłB
  *   ̃NX̃CX^X͌JꂽvpeBňʒuێĂ邽
  *   eՂɃANZX\ł邪Atɂ͗eՂȏӖĂB
  *   ̃NXgpƂ́ACX^X̃vpeB̒l^EȂƂ
  *   ҂ۏ؂Ȃ΂ȂȂB</p>
  * 
  * @history 2007/11/11 1.01.00 \bh(isEqual,isAfter,isBefore)ǉ
  * @history 2007/10/06 1.00.00 VK쐬
  */
  {
  //##############################################################################
  //
  // wb_(vpeBEpENXpX)
  //
  //
  // vpeB - NXɊւ郁^f[^
  //
  //:V Creator Function NXNG[^[
  var Creator = arguments.callee;
  // SCNX
  Creator.CompleteName = "js.debug.jsd.parser.SourcePoint";
  
  //
  // p - vg^CvpƊ{õZbg
  //
  // p
  Creator.inherit(Class, Super);
  //:V Static Object StaticIuWFNg
  var Static = Class.Static;
  //:V Proto Object vg^CvIuWFNg
  var Proto = Class.prototype;
  
  //
  // NXpX
  //
  
  //##############################################################################
  //
  // {fB(vCx[gENXEStaticEvg^CvE)
  //
  //
  // vCx[g - NX̔Joƃ\bh(pȂ)
  //
  
  //
  // NX - NX̌Joƃ\bh(pȂ)
  //
  
  //
  // Static - NX.StatičJoƃ\bh(p)
  //
  
  //
  // vg^Cv - NX.prototypěJoƃ\bh(p)
  //
  //------------------------------------------------------------------------------
  Proto.isBefore = function(point)
   /**
    * gΏۂÖʒuǂ肷
    * @param point js.debug.jsd.parser.SourcePoint rΏۃCX^X
    * @boolean gΏۂOł邩ǂiʒuȂfalsej
    * @throw FormatException@Error paramjs.debug.jsd.parser.SourcePoint^łȂꍇ
    */
    {
    if(!(point instanceof Class))
      {
      throw new Error("FormatException", Creator.CompleteName, {variable:"point", format:"js.debug.jsd.parser.SourcePoint", value:point, type:(typeof point)});
      }
    var isBefore = false;
    if(this != point)
      {
      if(this.lineNumber < point.lineNumber)
        {
        isBefore = true;
        }
      else if(this.lineNumber == point.lineNumber)
        {
        if(this.charIndex < point.charIndex)
          {
          isBefore = true;
          }
        }
      }
    return isBefore;
    };
  //------------------------------------------------------------------------------
  Proto.isAfter = function(point)
   /**
    * gΏۂ̈ʒuǂ肷
    * @param point js.debug.jsd.parser.SourcePoint rΏۃCX^X
    * @boolean gΏۂł邩ǂiʒuȂfalsej
    * @throw FormatException@Error paramjs.debug.jsd.parser.SourcePoint^łȂꍇ
    */
    {
    if(!(point instanceof Class))
      {
      throw new Error("FormatException", Creator.CompleteName, {variable:"point", format:"js.debug.jsd.parser.SourcePoint", value:point, type:(typeof point)});
      }
    var isAfter = false;
    if(this != point)
      {
      if(this.lineNumber > point.lineNumber)
        {
        isAfter = true;
        }
      else if(this.lineNumber == point.lineNumber)
        {
        if(this.charIndex > point.charIndex)
          {
          isAfter = true;
          }
        }
      }
    return isAfter;
    };
  //------------------------------------------------------------------------------
  Proto.isEqual = function(point)
   /**
    * gƑΏۂʒuǂ肷
    * @param point js.debug.jsd.parser.SourcePoint rΏۃCX^X
    * @boolean gƑΏۂʒuł邩ǂ
    * @throw FormatException@Error paramjs.debug.jsd.parser.SourcePoint^łȂꍇ
    * @notice <p>̃\bh̓CX^Xʒû݂̔rłA
    *   rΏۂTuNX̃CX^XłĂtrueԂƂB
    *   CX^X̓𔻒肵ꍇ<var>equals</var>\bhgp邱ƁB</p>
    */
    {
    if(!(point instanceof Class))
      {
      throw new Error("FormatException", Creator.CompleteName, {variable:"point", format:"js.debug.jsd.parser.SourcePoint", value:point, type:(typeof point)});
      }
    var isEqual = false;
    if(this == point)
      {
      isEqual = true;
      }
    else if(point instanceof Class)
      {
      if((this.lineNumber == point.lineNumber) && (this.charIndex == point.charIndex))
        {
        isEqual = true;
        }
      }
    return isEqual;
    };
  //------------------------------------------------------------------------------
  Proto.equals = function(obj)
   /**
    * eǂ肷
    * @param obj Object rΏۃCX^X
    * @boolean eǂ
    * @explanation <p>IuWFNgł邩ARXgN^ʒu\IuWFNgł邩AB</p>
    */
    {
    var isEqual = false;
    if(this == obj)
      {
      isEqual = true;
      }
    else if(obj instanceof Class)
      {
      if(this.constructor == obj.constructor)
        {
        isEqual = ((this.lineNumber == obj.lineNumber) && (this.charIndex == obj.charIndex));
        }
      else
        {
        isEqual = false;
        }
      }
    else
      {
      isEqual = false;
      }
    return isEqual;
    };
  //------------------------------------------------------------------------------
  Proto.clone = function()
   /**
    * N[쐬
    * @return js.debug.jsd.parser.SourcePoint N[IuWFNg
    */
    {
    var obj = new this.constructor();
    for(var i in this)
      {
      obj[i] = this[i];
      }
    return obj;
    };
  
  //
  //  - NX`ɂP񂾂s
  //
  
  //##############################################################################
  //
  // RXgN^(vCx[gEthisERXgN^)
  //
  function Class()
   /**
    * \[X|CgNX̃RXgN^
    * @return js.debug.jsd.parser.SourcePoint ̃NX̃CX^X
    */
    {
    //
    // X[p[NXKp(p) - X[p[NX̃RXgN^N
    //
    //Super.apply(this, arguments);
    
    //
    // vCx[g - CX^X̔Joƃ\bh(pȂ)
    //
    
    //
    // this - CX^X̌Joƃ\bh(Kpɂp)
    //
    //:i lineNumber Number s
    this.lineNumber = -1;
    //:i charIndex Number ʒuisj
    this.charIndex = -1;
    
    //
    // RXgN^ - CX^X̌Joƃ\bh(pȂ)
    //
    return this;
    }
  
  return Class;
  });

