(function()
 /**
  * JavaScriptDocumentpbP[W
  * 
  * @package js.debug.jsd
  * @update 2007/03/17
  * @version 1.04.01
  * @author Mug
  * @copyright (C) 2005-2007 Mug, All rights reserved.
  * 
  * @explanation <p>̃pbP[WJavaScriptDocumentiȉAJSDƗj͂A
  *   JSDɋLqꂽCX^X邽߂ɕKvȃNX`ĂB<br />
  *   ȂACX^Xo͂邽߂̋̓IȎ͊܂܂ĂȂB</p>
  */
  {
  //------------------------------------------------------------------------------
  // NXpX
  
  //:V Package Function js.cpt.PackageNX
  var Package = js.cpt.Package;
  
  //:V Class Function js.cpt.ClassNX
  var Class = js.cpt.Class;
  
  //------------------------------------------------------------------------------
  // pbP[W
  
  //:V jsd js.cpt.Package JSDpbP[W
  var jsd = Package.getInstance("js.debug.jsd");
  
  //------------------------------------------------------------------------------
  // NX`
  
  //:I JsdFactory@js.debug.jsd js.cpt.Class JsdFactory(JSDt@Ng[)NX
  jsd.JsdFactory = new Class("JsdFactory",
    ["js.cpt.Log", "js.debug.jsd.parser.AbstractParser", "js.debug.jsd.parser.SourcePoint", "js.debug.jsd.parser.SourceRange", "js.debug.jsd.JavaScriptDocument"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I JavaScriptDocument@js.debug.jsd js.cpt.Class JavaScriptDocument(JSD)NX
  jsd.JavaScriptDocument = new Class("JavaScriptDocument",
    ["js.debug.jsd.command.AbstractCommand"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  // p[T[
  
  //:V psr js.cpt.Package JSD̃p[T[pbP[W
  var psr = Package.getInstance("js.debug.jsd.parser");
  
  //:I SourcePoint@js.debug.jsd.parser js.cpt.Class \[X|CgNX
  psr.SourcePoint = new Class("SourcePoint",
    null,
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I SourceRange@js.debug.jsd.parser js.cpt.Class \[XWNX
  psr.SourceRange = new Class("SourceRange",
    ["js.debug.jsd.parser.SourcePoint"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  
  //:I AbstractParser@js.debug.jsd.parser js.cpt.Class JSDp[T[ۃNX
  psr.AbstractParser = new Class("AbstractParser",
    ["js.debug.jsd.parser.SourcePoint", "js.debug.jsd.parser.SourceRange"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  
  //:I SingleLineCommentIgnore@js.debug.jsd.parser js.cpt.Class JSDp[T[(PsRg)NX
  psr.SingleLineCommentIgnore = new Class("SingleLineCommentIgnore",
    ["js.debug.jsd.parser.AbstractParser", "js.debug.jsd.parser.SourcePoint", "js.debug.jsd.parser.SourceRange", "js.debug.jsd.JavaScriptDocument", "js.debug.jsd.command.AbstractCommand", "js.debug.jsd.command.*", "js.debug.jsd.JsdFactory"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I MultiLineCommentIgnore@js.debug.jsd.parser js.cpt.Class JSDp[T[(sRg)NX
  psr.MultiLineCommentIgnore = new Class("MultiLineCommentIgnore",
    ["js.debug.jsd.parser.AbstractParser", "js.debug.jsd.parser.SourcePoint", "js.debug.jsd.parser.SourceRange", "js.debug.jsd.JavaScriptDocument", "js.debug.jsd.command.AbstractCommand", "js.debug.jsd.command.*", "js.debug.jsd.JsdFactory"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I StringLiteralIgnore1@js.debug.jsd.parser js.cpt.Class JSDp[T[(񃊃e)NX
  psr.StringLiteralIgnore1 = new Class("StringLiteralIgnore1",
    ["js.debug.jsd.parser.AbstractParser", "js.debug.jsd.parser.SourcePoint", "js.debug.jsd.parser.SourceRange", "js.debug.jsd.JavaScriptDocument", "js.debug.jsd.command.AbstractCommand", "js.debug.jsd.command.*", "js.debug.jsd.JsdFactory"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I StringLiteralIgnore2@js.debug.jsd.parser js.cpt.Class JSDp[T[(񃊃e)NX
  psr.StringLiteralIgnore2 = new Class("StringLiteralIgnore2",
    ["js.debug.jsd.parser.AbstractParser", "js.debug.jsd.parser.SourcePoint", "js.debug.jsd.parser.SourceRange", "js.debug.jsd.JavaScriptDocument", "js.debug.jsd.command.AbstractCommand", "js.debug.jsd.command.*", "js.debug.jsd.JsdFactory"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I RegExpLiteralIgnore@js.debug.jsd.parser js.cpt.Class JSDp[T[(K\e)NX
  psr.RegExpLiteralIgnore = new Class("RegExpLiteralIgnore",
    ["js.debug.jsd.parser.AbstractParser", "js.debug.jsd.parser.SourcePoint", "js.debug.jsd.parser.SourceRange", "js.debug.jsd.JavaScriptDocument", "js.debug.jsd.command.AbstractCommand", "js.debug.jsd.command.*", "js.debug.jsd.JsdFactory"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I SingleLineJsdParser@js.debug.jsd.parser js.cpt.Class JSDp[T[(PsJSD)NX
  psr.SingleLineJsdParser = new Class("SingleLineJsdParser",
    ["js.debug.jsd.parser.AbstractParser", "js.debug.jsd.parser.SourcePoint", "js.debug.jsd.parser.SourceRange", "js.debug.jsd.JavaScriptDocument", "js.debug.jsd.command.AbstractCommand", "js.debug.jsd.command.*", "js.debug.jsd.JsdFactory", "js.debug.jsd.parser.SingleLineCommentIgnore"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I MultiLineJsdParser@js.debug.jsd.parser js.cpt.Class JSDp[T[(sJSD)NX
  psr.MultiLineJsdParser = new Class("MultiLineJsdParser",
    ["js.debug.jsd.parser.AbstractParser", "js.debug.jsd.parser.SourcePoint", "js.debug.jsd.parser.SourceRange", "js.debug.jsd.JavaScriptDocument", "js.debug.jsd.command.AbstractCommand", "js.debug.jsd.command.*", "js.debug.jsd.JsdFactory", "js.debug.jsd.parser.MultiLineCommentIgnore"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  // R}h
  
  //:V cmd js.cpt.Package JSD̃R}hpbP[W
  var cmd = Package.getInstance("js.debug.jsd.command");
  
  //:I AbstractCommand@js.debug.jsd.command js.cpt.Class JavaScriptDocument(JSD)ۃR}hNX
  cmd.AbstractCommand = new Class("AbstractCommand",
    ["js.debug.jsd.command.element.AbstractElement"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I Title@js.debug.jsd.command js.cpt.Class JSDR}h(title)NX
  cmd.Title = new js.cpt.Class("Title",
    ["js.debug.jsd.command.AbstractCommand", "js.debug.jsd.command.element.*"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I Name@js.debug.jsd.command js.cpt.Class JSDR}h(name)NX
  cmd.Name = new js.cpt.Class("Name",
    ["js.debug.jsd.command.AbstractCommand", "js.debug.jsd.command.element.*"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I Definition@js.debug.jsd.command js.cpt.Class JSDR}h(def)NX
  cmd.Definition = new js.cpt.Class("Definition",
    ["js.debug.jsd.command.AbstractCommand", "js.debug.jsd.command.element.*"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I Attribute@js.debug.jsd.command js.cpt.Class JSDR}h(attrib)NX
  cmd.Attribute = new js.cpt.Class("Attribute",
    ["js.debug.jsd.command.AbstractCommand", "js.debug.jsd.command.element.*"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I Type@js.debug.jsd.command js.cpt.Class JSDR}h(type)NX
  cmd.Type = new js.cpt.Class("Type",
    ["js.debug.jsd.command.AbstractCommand", "js.debug.jsd.command.element.*"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I Value@js.debug.jsd.command js.cpt.Class JSDR}h(value)NX
  cmd.Value = new js.cpt.Class("Value",
    ["js.debug.jsd.command.AbstractCommand", "js.debug.jsd.command.element.*"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I Package@js.debug.jsd.command js.cpt.Class JSDR}h(package)NX
  cmd.Package = new js.cpt.Class("Package",
    ["js.debug.jsd.command.AbstractCommand", "js.debug.jsd.command.element.*"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I Update@js.debug.jsd.command js.cpt.Class JSDR}h(update)NX
  cmd.Update = new js.cpt.Class("Update",
    ["js.debug.jsd.command.AbstractCommand", "js.debug.jsd.command.element.*"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I Version@js.debug.jsd.command js.cpt.Class JSDR}h(version)NX
  cmd.Version = new js.cpt.Class("Version",
    ["js.debug.jsd.command.AbstractCommand", "js.debug.jsd.command.element.*"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I History@js.debug.jsd.command js.cpt.Class JSDR}h(history)NX
  cmd.History = new js.cpt.Class("History",
    ["js.debug.jsd.command.AbstractCommand", "js.debug.jsd.command.element.*"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I Author@js.debug.jsd.command js.cpt.Class JSDR}h(author)NX
  cmd.Author = new js.cpt.Class("Author",
    ["js.debug.jsd.command.AbstractCommand", "js.debug.jsd.command.element.*"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I Copyright@js.debug.jsd.command js.cpt.Class JSDR}h(copyright)NX
  cmd.Copyright = new js.cpt.Class("Copyright",
    ["js.debug.jsd.command.AbstractCommand", "js.debug.jsd.command.element.*"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I Param@js.debug.jsd.command js.cpt.Class JSDR}h(param)NX
  cmd.Param = new js.cpt.Class("Param",
    ["js.debug.jsd.command.AbstractCommand", "js.debug.jsd.command.element.*"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I Params@js.debug.jsd.command js.cpt.Class JSDR}h(params)NX
  cmd.Params = new js.cpt.Class("Params",
    ["js.debug.jsd.command.AbstractCommand", "js.debug.jsd.command.element.*"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I Return@js.debug.jsd.command js.cpt.Class JSDR}h(return)NX
  cmd.Return = new js.cpt.Class("Return",
    ["js.debug.jsd.command.AbstractCommand", "js.debug.jsd.command.element.*"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I Throw@js.debug.jsd.command js.cpt.Class JSDR}h(throw)NX
  cmd.Throw = new js.cpt.Class("Throw",
    ["js.debug.jsd.command.AbstractCommand", "js.debug.jsd.command.element.*"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I This@js.debug.jsd.command js.cpt.Class JSDR}h(this)NX
  cmd.This = new js.cpt.Class("This",
    ["js.debug.jsd.command.AbstractCommand", "js.debug.jsd.command.element.*"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I Condition@js.debug.jsd.command js.cpt.Class JSDR}h(condition)NX
  cmd.Condition = new js.cpt.Class("Condition",
    ["js.debug.jsd.command.AbstractCommand", "js.debug.jsd.command.element.*"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I Notice@js.debug.jsd.command js.cpt.Class JSDR}h(notice)NX
  cmd.Notice = new js.cpt.Class("Notice",
    ["js.debug.jsd.command.AbstractCommand", "js.debug.jsd.command.element.*"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I Explanation@js.debug.jsd.command js.cpt.Class JSDR}h(explanation)NX
  cmd.Explanation = new js.cpt.Class("Explanation",
    ["js.debug.jsd.command.AbstractCommand", "js.debug.jsd.command.element.*"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I Example@js.debug.jsd.command js.cpt.Class JSDR}h(example)NX
  cmd.Example = new js.cpt.Class("Example",
    ["js.debug.jsd.command.AbstractCommand", "js.debug.jsd.command.element.*"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I Reference@js.debug.jsd.command js.cpt.Class JSDR}h(ref)NX
  cmd.Reference = new js.cpt.Class("Reference",
    ["js.debug.jsd.command.AbstractCommand", "js.debug.jsd.command.element.*"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I Relation@js.debug.jsd.command js.cpt.Class JSDR}h(rel)NX
  cmd.Relation = new js.cpt.Class("Relation",
    ["js.debug.jsd.command.AbstractCommand", "js.debug.jsd.command.element.*"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  // Gg
  
  //:V elm js.cpt.Package JSD̃GgpbP[W
  var elm = Package.getInstance("js.debug.jsd.command.element");
  
  //:I AbstractElement@js.debug.jsd.command.element js.cpt.Class JavaScriptDocument(JSD)R}hvfۃNX
  elm.AbstractElement = new Class("AbstractElement", 
    null,
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I VariableElement@js.debug.jsd.command.element js.cpt.Class JSDR}hvf(Variable)NX
  elm.VariableElement = new Class("VariableElement", 
    ["js.debug.jsd.command.element.AbstractElement"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I MemberElement@js.debug.jsd.command.element js.cpt.Class JSDR}hvf(Member)NX
  elm.MemberElement = new Class("MemberElement", 
    ["js.debug.jsd.command.element.AbstractElement"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I PackageElement@js.debug.jsd.command.element js.cpt.Class JSDR}hvf(Package)NX
  elm.PackageElement = new Class("PackageElement", 
    ["js.debug.jsd.command.element.AbstractElement"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I ClassElement@js.debug.jsd.command.element js.cpt.Class JSDR}hvf(Class)NX
  elm.ClassElement = new Class("ClassElement", 
    ["js.debug.jsd.command.element.AbstractElement"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I ClassesElement@js.debug.jsd.command.element js.cpt.Class JSDR}hvf(Classes)NX
  elm.ClassesElement = new Class("ClassesElement", 
    ["js.debug.jsd.command.element.AbstractElement"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I DateElement@js.debug.jsd.command.element js.cpt.Class JSDR}hvf(Date)NX
  elm.DateElement = new Class("DateElement", 
    ["js.debug.jsd.command.element.AbstractElement"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I VersionElement@js.debug.jsd.command.element js.cpt.Class JSDR}hvf(Version)NX
  elm.VersionElement = new Class("VersionElement", 
    ["js.debug.jsd.command.element.AbstractElement"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I DefTypeElement@js.debug.jsd.command.element js.cpt.Class JSDR}hvf(DefType)NX
  elm.DefTypeElement = new Class("DefTypeElement", 
    ["js.debug.jsd.command.element.AbstractElement"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I WordElement@js.debug.jsd.command.element js.cpt.Class JSDR}hvf(Word)NX
  elm.WordElement = new Class("WordElement", 
    ["js.debug.jsd.command.element.AbstractElement"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I WordsElement@js.debug.jsd.command.element js.cpt.Class JSDR}hvf(Words)NX
  elm.WordsElement = new Class("WordsElement", 
    ["js.debug.jsd.command.element.AbstractElement"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I UrlElement@js.debug.jsd.command.element js.cpt.Class JSDR}hvf(URL)NX
  elm.UrlElement = new Class("UrlElement", 
    ["js.debug.jsd.command.element.AbstractElement"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I TextElement@js.debug.jsd.command.element js.cpt.Class JSDR}hvf(Text)NX
  elm.TextElement = new Class("TextElement", 
    ["js.debug.jsd.command.element.AbstractElement"],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  }
)();

