Class.create(function(Super)
 /**
  * \[X́iPsircjNX
  * @param Super [Function|null] X[p[NX
  * @return Function js.debug.jsd.parser.SingleLineJsdParserNX
  * 
  * @package js.debug.jsd.parser
  * @update 2007/12/29
  * @version 1.02.00
  * @author Mug
  * @copyright (C) 2007 Mug, All rights reserved.
  * 
  * @history 2007/12/29 1.02.00 t@Ng[ɓo^悤ɕύX
  * @history 2007/10/27 1.01.00 attribLq\ɕύX
  * @history 2007/10/06 1.00.00 VK쐬
  * 
  * @explanation <p>̃NXJSD̂߂̃\[XR[h͂ɂāAPsRĝJSDRgJSDIuWFNgɕϊNXłB</p>
  */
  {
  //##############################################################################
  //
  // wb_(vpeBEpENXpX)
  //
  //
  // vpeB - NXɊւ郁^f[^
  //
  //:V Creator Function NXNG[^[
  var Creator = arguments.callee;
  // SCNX
  Creator.CompleteName = "js.debug.jsd.parser.SingleLineJsdParser";
  
  //
  // p - vg^CvpƊ{õZbg
  //
  // p
  Creator.inherit(Class, Super);
  //:V Static Object StaticIuWFNg
  var Static = Class.Static;
  //:V Proto Object vg^CvIuWFNg
  var Proto = Class.prototype;
  
  //
  // NXpX
  //
  // js.debug.jsd.JsdFactory
  var JsdFactory = js.debug.jsd.JsdFactory;
  
  //:V JavaScriptDocument Function js.debug.jsd.JavaScriptDocument̎Q
  var JavaScriptDocument = js.debug.jsd.JavaScriptDocument;
  //:V SourcePoint Function js.debug.jsd.parser.SourcePoint̎Q
  var SourcePoint = js.debug.jsd.parser.SourcePoint;
  
  //##############################################################################
  //
  // {fB(vCx[gENXEStaticEvg^CvE)
  //
  //
  // vCx[g - NX̔Joƃ\bh(pȂ)
  //
  //:V JSD_PATTERN RegExp JSD̋Lqp^[
  var JSD_PATTERN = /^\/\/:(\S)\s+(\S+)\s+(\S+)(?:\s+(?:\{([^{}]*)\}\s*)?(.+?))?$/;
  
  //
  // NX - NX̌Joƃ\bh(pȂ)
  //
  
  //
  // Static - NX.StatičJoƃ\bh(p)
  //
  //:S PATTERN RegExp|null Y(/(\/\/:.*?)(?:\r|\n|$)/g)
  Static.PATTERN = /(\/\/:.*?)(?:\r|\n|$)/g;
  //:S ALTERNATE String|null ֕i󕶎j
  Static.ALTERNATE = "";
  
  //
  // vg^Cv - NX.prototypěJoƃ\bh(p)
  //
  //------------------------------------------------------------------------------
  Proto.parse = function(aroundSource)
   /**
    * \[XJSDIuWFNgɃp[X
    * @condition aroundSource̓RgO\[XłȂ΂ȂȂB
    * @param aroundSource [Array|String|null] ͂̃\[X
    * @return js.debug.jsd.JavaScriptDocument|null ͂ĐꂽJSDCX^X
    * @throw StringFormatException@Error RXgN^rangevaluevpeBv~eBuString^łȂꍇ
    * @throw StringRangeException@Error RXgN^rangevaluevpeBϐJSD_PATTERN̐K\𖞂Ȃꍇ
    * @throw FormatException@Error aroundSourceArray^łv~eBuString^łnullł`łȂꍇ
    * @throw StringFormatException@Error aroundSourceArray^ł̗vfɃv~eBuString^łȂ̂܂܂Ăꍇ
    */
    {
    var range = this.getRange();
    if((typeof range.value) != "string")
      {
      throw new Error("StringFormatException", Creator.CompleteName, {variable:"range.value", value:range.value, type:(typeof range.value)});
      }
    if(!JSD_PATTERN.test(range.value))
      {
      throw new Error("StringRangeException", Creator.CompleteName, {variable:"range.value", range:("/"+JSD_PATTERN.source+"/"), value:range.value, type:(typeof range.value)});
      }
    if((aroundSource !== undefined) && (aroundSource !== null) && ((typeof aroundSource) != "string") && !(aroundSource instanceof Array))
      {
      throw new Error("FormatException", Creator.CompleteName, {variable:"aroundSource", format:"[Array|String|null]", value:aroundSource, type:(typeof aroundSource)});
      }
    if(aroundSource instanceof Array)
      {
      for(var i = 0; i < aroundSource.length; i++)
        {
        if((typeof aroundSource[i]) != "string")
          {
          throw new Error("StringFormatException", Creator.CompleteName, {variable:("aroundSource["+i+"]"), value:aroundSource[i], type:(typeof aroundSource[i])});
          }
        }
      }
    // 
    if((typeof aroundSource) == "string")
      {
      if(!aroundSource)
        {
        aroundSource = null;
        }
      else if(aroundSource.indexOf("\r", 0) < 0)
        {
        aroundSource = aroundSource.split("\n");
        }
      else if(aroundSource.indexOf("\n", 0) < 0)
        {
        aroundSource = aroundSource.split("\r");
        }
      else
        {
        aroundSource = aroundSource.replace(/\r/g, "").split("\n");
        }
      }
    // JSDCX^X̐
    var matches = JSD_PATTERN.exec(range.value)
    var def  = js.debug.jsd.command.Definition.Static.parse(matches[1]);
    var name = js.debug.jsd.command.Name.Static.parse(matches[2]);
    var type = js.debug.jsd.command.Type.Static.parse(matches[3]);
    var jsd  = new JavaScriptDocument();
    jsd.addCommand(def);
    jsd.addCommand(name);
    jsd.addCommand(type);
    if(matches[4])
      {
      jsd.addCommand(js.debug.jsd.command.Attribute.Static.parse(matches[4]));
      }
    if(matches[5])
      {
      jsd.addCommand(js.debug.jsd.command.Title.Static.parse(matches[5]));
      }
    this.jsd = jsd;
    // ^[Qbǧ
    if(aroundSource)
      {
      var target = null;
      // s(O)
      if(!target && (range.begin instanceof SourcePoint) && ((typeof range.begin.lineNumber) == "number") && (0 <= range.begin.lineNumber) && (aroundSource.length > range.begin.lineNumber))
        {
        var src = aroundSource[range.begin.lineNumber];
        if(((typeof range.begin.charIndex) == "number") && (0 <= range.begin.charIndex) && (range.begin.charIndex < src.length))
          {
          src = src.substring(0, range.begin.charIndex);
          }
        target = Static.findTarget(src);
        if(target)
          {
          target.begin.lineNumber = range.begin.lineNumber;
          target.end.lineNumber = range.begin.lineNumber;
          }
        if(target && ((target.value != name.getValue(name.getNames()[0])) || (target.def.toUpperCase() != def.getValue(def.getNames()[0]).toUpperCase())))
          {
          target = null;
          }
        }
      // ̍s
      if(!target && (range.end instanceof SourcePoint) && ((typeof range.end.lineNumber) == "number") && (0 <= (range.end.lineNumber + 1)) && (aroundSource.length > (range.end.lineNumber + 1)))
        {
        var src = aroundSource[range.end.lineNumber + 1];
        target = Static.findTarget(src);
        if(target)
          {
          target.begin.lineNumber = range.end.lineNumber + 1;
          target.end.lineNumber = range.end.lineNumber + 1;
          }
        if(target && ((target.value != name.getValue(name.getNames()[0])) || (target.def.toUpperCase() != def.getValue(def.getNames()[0]).toUpperCase())))
          {
          target = null;
          }
        }
      // O̍s
      if(!target && (range.begin instanceof SourcePoint) && ((typeof range.begin.lineNumber) == "number") && (0 <= (range.begin.lineNumber - 1)) && (aroundSource.length > (range.begin.lineNumber - 1)))
        {
        var src = aroundSource[range.begin.lineNumber - 1];
        target = Static.findTarget(src);
        if(target)
          {
          target.begin.lineNumber = range.begin.lineNumber - 1;
          target.end.lineNumber = range.begin.lineNumber - 1;
          }
        if(target && ((target.value != name.getValue(name.getNames()[0])) || (target.def.toUpperCase() != def.getValue(def.getNames()[0]).toUpperCase())))
          {
          target = null;
          }
        }
      // ^[Qbgm
      if(target)
        {
        this.target = target;
        }
      }
    // JSDCX^X̕ԋp
    return jsd;
    };
  
  //
  //  - NX`ɂP񂾂s
  //
  // t@Ng[ɓo^
  JsdFactory.registParser(Class);
  
  //##############################################################################
  //
  // RXgN^(vCx[gEthisERXgN^)
  //
  function Class(range)
   /**
    * \[X́iPsircjNX̃RXgN^
    * @param range js.debug.jsd.parser.SourceRange ͑Ώۂ̃\[X͈̔͂ƒl
    * @return js.debug.jsd.parser.SingleLineJsdParser ̃NX̃CX^X
    */
    {
    //
    // X[p[NXKp(p) - X[p[NX̃RXgN^N
    //
    Super.apply(this, arguments);
    
    //
    // vCx[g - CX^X̔Joƃ\bh(pȂ)
    //
    
    //
    // this - CX^X̌Joƃ\bh(Kpɂp)
    //
    
    //
    // RXgN^ - CX^X̌Joƃ\bh(pȂ)
    //
    return this;
    }
  
  return Class;
  }, js.debug.jsd.parser.AbstractParser);

